#################################################################################################
# Shoutbox.pm:      Part of the Shoutbox Mod                                                    #
# Copyright:        2005 Andrew Aitken (LoonyPandora)                                           #
# Version:          Shoutbox for YaBB 2.6.0                                                     #
# Released:         14th Aug, 2014                                                              #
# Distributed by:   http://www.yabbforumsoftware.com                                            #
# Update by:        Batchman, Derek Barnstorm, D0T-C0M, Driven, Unilat, ThM with permission     #
# Update to 2.6.0 by Dandello                                                                   #
#################################################################################################
use CGI::Carp qw(fatalsToBrowser);
use English qw(-no_match_vars);
our $VERSION = '2.6.0';

$shoutboxpmver = 'Shoutbox Mod for YaBB 2.6.0';
if ( $action eq 'detailedversion' ) { return 1; }

LoadLanguage('Post');
LoadLanguage('Shoutbox');

if ( !-e "$vardir/shoutsettings.txt" ) {
    fatal_error("$shout_txt{'7'}");
}
else {
    require "$vardir/shoutsettings.txt";
}
$shout_time = GetShoutTime();

sub WriteShouts {

    #&spam_protection;

    CheckCanShout();
    my $shout_message  = $FORM{'shoutout'};
    my $shout_username = $username;
    my $shout_name     = ${ $uid . $username }{'realname'};

    if ($shout_message) {
        $shout_message = WriteSpecialChars($shout_message);
        $new_shout =
          qq~$shout_time|$shout_name|$shout_username|$shout_message\n~;
        fopen( SHOUTS, "+<$vardir/shouts.txt" );
        @shouts = <SHOUTS>;
        push @shouts, $new_shout;

        if ( $#shouts > $maximum_shouts ) { shift @shouts; }

        seek SHOUTS, 0, 0;
        truncate SHOUTS, 0;
        print {SHOUTS} @shouts or croak "$croak{'print'} SHOUTS";
        fclose(SHOUTS);
    }

    if ( !$iamguest ) { UpdateShoutCount(); }
    if ( $INFO{'showall'} ) {
        $yySetLocation = qq~$boardurl/ShoutDisplay.pl?showall=1~;
    }

    else { $yySetLocation = qq~$boardurl/ShoutDisplay.pl~; }
    redirectexit();
    return;
}

sub UpdateShoutCount {

    # Increment shout count
    ${ $uid . $username }{'lp_shoutcount'}++;
    ${ $uid . $username }{'lp_lastshout'} = $shout_time;
    UserAccount( $username, 'update' );
    return;
}

sub GetShoutTime {
    my $shout_time = int time;
    return $shout_time;
}

sub WriteSpecialChars {
    $message = $_[0];
    ToHTML($message);

    # Remove img tags
    $message =~ s/\[img(.*)?\](.*)\[\/img\]/$2/ixsm;
    $message =~ s/\[size=(.+?)\](.+?)\[\/size\]/my_sizefont($1,$2)/eigsxm;
    return $message;
}

sub my_sizefont {
    # limit minimum and maximum font pitch as CSS does not restrict it at all
    my ( $tsize, $ttext ) = @_;
    $fontsizemax = 20;
    $fontsizemin = 6;
    if    ( $tsize < $fontsizemin ) { $tsize = $fontsizemin; }
    elsif ( $tsize > $fontsizemax ) { $tsize = $fontsizemax; }
    my $resized = qq~\[size=$tsize]$ttext\[/size]~;
    return $resized;
}

sub UserRemoveShouts {
    $shout_name = $INFO{'user'};
    if ( $username eq $shout_name || $iamadmin ) {
        $shout_to_delete = $INFO{'shout'};
        fopen( SHOUTS, "+<$vardir/shouts.txt" )
          || fatal_error( "$shout_txt{'8'} $vardir/shouts.txt - $ERRNO", 1 );
        my $buffer = 1;
        my $found  = 0;
        while ($buffer) {
            $offset = tell SHOUTS;
            $buffer = <SHOUTS>;
            if ( $buffer =~ m/\A$shout_to_delete/xsm ) {
                $slice = ( $INPUT_LINE_NUMBER - 1 );
                $found = 1;
                last;
            }
        }
        if ($found) {
            seek SHOUTS, 0, 0;
            my @contents = <SHOUTS>;
            $contents[$slice] = q~~;
            seek SHOUTS, 0, 0;
            truncate SHOUTS, 0;
            print {SHOUTS} @contents  or croak "$croak{'print'} SHOUTS";
        }
        fclose(SHOUTS);
        if ( $INFO{'showall'} ) {
            $yySetLocation = qq~$boardurl/ShoutDisplay.pl?showall=1~;
        }
        else { $yySetLocation = qq~$boardurl/ShoutDisplay.pl~; }

        redirectexit();
    }
    else {
        fatal_error('shout_delete');
    }
    return;
}

sub ShoutSmileys {
    if ( $smiliestyle == 1 ) { $smiliewinlink = "$scripturl?action=smilieput"; }
    else { $smiliewinlink = "$scripturl?action=smilieindex"; }
    print qq~Content-type:text/html\n\n~  or croak "$croak{'print'} TOP";
    print qq~
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
    <title>$name_sb</title>
    <meta http-equiv="Content-Type" content="text/html; charset=$yymycharset" />
    <link rel="stylesheet" href="$yyhtml_root/Templates/Forum/$usestyle.css" type="text/css" />
</head>
<body>
    <div style="float: left; width: 360px;">
        <br />
        <form name="addsmileys">
~  or croak "$croak{'print'} BODY";
    ShoutBBCode();
    NormalSmileys();
    AddMoreSmileys();
    return;
}

sub ShoutBBCode {
    print
      qq~<script src="$yyhtml_root/shout.js" type="text/javascript"></script>~  or croak "$croak{'print'} SHOUTS";
    if ( $enable_ubbc && $showyabbcbutt ) {
        my %ubbcode_bar = (
            'a' => "bold.png|bold()|$post_txt{'253'}",
            'b' => "italicize.png|italicize()|$post_txt{'254'}",
            'c' => "underline.png|underline()|$post_txt{'255'}",
            'd' => "strike.png|strike()|$post_txt{'441'}",
            'e' => "move.png|move()|$post_txt{'439'}",
            'f' => "tele.png|teletype()|$post_txt{'440'}",
            'g' => "url.png|url()|$post_txt{'257'}",
            'h' => "email2.png|emai1()|$post_txt{'258'}",
            'i' => "sup.png|superscript()|$post_txt{'447'}",
            'j' => "sub.png|subscript()|$post_txt{'448'}",
        );
        ( $bbcode_bar, $boxlist1_w ) = ubbc_boxlist(%ubbcode_bar);
        my $indent = int(360 - $boxlist1_w)/2;
        print qq~
<table>
    <tr>
        <td style="padding-left:${indent}px">
            $bbcode_bar
            <script type="text/javascript">
            // Palette
            var thistask = 'post';
            function tohex(i) {
                a2 = ''
                ihex = hexQuot(i);
                idiff = eval(i + '-(' + ihex + '*16)')
                a2 = itohex(idiff) + a2;
                while( ihex >= 16) {
                    itmp = hexQuot(ihex);
                    idiff = eval(ihex + '-(' + itmp + '*16)');
                    a2 = itohex(idiff) + a2;
                    ihex = itmp;
                }
                a1 = itohex(ihex);
                return a1 + a2 ;
            }

            function hexQuot(i) {
                return Math.floor(eval(i +'/16'));
            }

            function itohex(i) {
                if( i == 0) { aa = '0' }
                else { if( i == 1 ) { aa = '1' }
                else { if( i == 2 ) { aa = '2' }
                else { if( i == 3 ) { aa = '3' }
                else { if( i == 4 ) { aa = '4' }
                else { if( i == 5 ) { aa = '5' }
                else { if( i == 6 ) { aa = '6' }
                else { if( i == 7 ) { aa = '7' }
                else { if( i == 8 ) { aa = '8' }
                else { if( i == 9 ) { aa = '9' }
                else { if( i == 10) { aa = 'a' }
                else { if( i == 11) { aa = 'b' }
                else { if( i == 12) { aa = 'c' }
                else { if( i == 13) { aa = 'd' }
                else { if( i == 14) { aa = 'e' }
                else { if( i == 15) { aa = 'f' }
                }}}}}}}}}}}}}}}
                return aa;
            }

            function ConvShowcolor(color) {
                if ( c=color.match(/rgb\\((\\d+?)\\, (\\d+?)\\, (\\d+?)\\)/i) ) {
                    var rhex = tohex(c[1]);
                    var ghex = tohex(c[2]);
                    var bhex = tohex(c[3]);
                    var newcolor = '#'+rhex+ghex+bhex;
                }
                else {
                    var newcolor = color;
                }
                if(thistask == "post") showcolor(newcolor);
                if(thistask == "templ") previewColor(newcolor);
            }
            </script>
            <img src="$imagesdir/palette1.gif" style="cursor: pointer; margin:0 -2px" width='23' height='22' onclick="window.open('$scripturl?action=palette;task=post', '', 'height=308,width=302,menubar=no,toolbar=no,scrollbars=no')" alt="" />
        </td>
    </tr>
</table>
~  or croak "$croak{'print'} JS";
    }
    else { print qq~<p class="small center">$post_txt{'215'}</p>~  or croak "$croak{'print'} NO JS"; }

    # Change Colour section
    print qq~
<table>
    <tr>
        <td class="center">$shout_txt{'35'}</td>
    </tr><tr>
        <td class="center">
            <select name="fontface" id="fontface" onchange="if(this.options[this.selectedIndex].value) fontfce(this.options[this.selectedIndex].value);">
                <option value="Verdana">Verdana</option>
                <option value="">-\\-\\-\\-\\-\\-\\-\\-\\-</option>
                <option value="Arial" style="font-family: Arial">Arial</option>
                <option value="Bitstream Vera Sans Mono" style="font-family: Bitstream Vera Sans Mono">Bitstream</option>
                <option value="Bradley Hand ITC" style="font-family: Bradley Hand ITC">Bradley Hand ITC</option>
                <option value="Comic Sans MS" style="font-family: Comic Sans MS">Comic Sans MS</option>
                <option value="Courier" style="font-family: Courier">Courier</option>
                <option value="Courier New" style="font-family: Courier New">Courier New</option>
                <option value="Georgia" style="font-family: Georgia">Georgia</option>
                <option value="Impact" style="font-family: Impact">Impact</option>
                <option value="Lucida Sans" style="font-family: Lucida Sans">Lucida Sans</option>
                <option value="Microsoft Sans Serif" style="font-family: Microsoft Sans Serif">MS Sans Serif</option>
                <option value="Papyrus" style="font-family: Papyrus">Papyrus</option>
                <option value="Tahoma" style="font-family: Tahoma">Tahoma</option>
                <option value="Tempus Sans ITC" style="font-family: Tempus Sans ITC">Tempus Sans ITC</option>
                <option value="Times New Roman" style="font-family: Times New Roman">Times New Roman</option>
                <option value="Verdana" style="font-family: Verdana" selected="selected">Verdana</option>
            </select>
            <select name="fontsize" id="fontsize" onchange="if(this.options[this.selectedIndex].value) fntsize(this.options[this.selectedIndex].value);">
                <option value="">11</option>
                <option value="">-\\-</option>~  or croak "$croak{'print'} color";
    my @fntoptions =
      ( 6, 7, 8, 9, 10, 11, 12, 14, 16, 18, 20, 22, 24, 36, 48, 56, 72 );
    my $fntopts = q{};
    for my $i ( 0 .. ( @fntoptions - 1 ) ) {
        if (   $fntoptions[$i] >= $fontsizemin
            && $fntoptions[$i] <= $fontsizemax )
        {
            if ( $fntoptions[$i] == 11 ) {
                $fntopts .=
qq~               <option value="11" selected="selected">11</option>\n~;
            }
            else {
                $fntopts .=
qq~              <option value="$fntoptions[$i]">$fntoptions[$i]</option>\n~;
            }
        }
    }
    print qq~
$fntopts
            </select>
      </td>
    </tr>
</table>
<br />
~  or croak "$croak{'print'} end color";
    return;
}

sub NormalSmileys {
    %smiley_bar = (
        'a' => "smiley.gif|smiley()|$post_txt{'287'}",
        'b' => "wink.gif|wink()|$post_txt{'292'}",
        'c' => "cheesy.gif|cheesy()|$post_txt{'289'}",
        'd' => "grin.gif|grin()|$post_txt{'293'}",
        'e' => "angry.gif|angry()|$post_txt{'288'}",
        'f' => "sad.gif|sad()|$post_txt{'291'}",
        'g' => "shocked.gif|shocked()|$post_txt{'294'}",
        'h' => "cool.gif|cool()|$post_txt{'295'}",
        'i' => "huh.gif|huh()|$post_txt{'296'}",
        'j' => "rolleyes.gif|rolleyes()|$post_txt{'450'}",
        'k' => "tongue.gif|tongue()|$post_txt{'451'}",
        'l' => "embarassed.gif|embarassed()|$post_txt{'526'}",
        'm' => "lipsrsealed.gif|lipsrsealed()|$post_txt{'527'}",
        'n' => "undecided.gif|undecided()|$post_txt{'528'}",
        'o' => "kiss.gif|kiss()|$post_txt{'529'}",
        'p' => "cry.gif|cry()|$post_txt{'530'}",
    );
    $smiley_bar = smiley_list(%smiley_bar);
    print qq~
<table>
      <tr>
        <td class="center">
        $smiley_bar
        </td></tr>
    </table>
~  or croak "$croak{'print'} Smileys";
    return;
}

sub AddMoreSmileys {
    print qq~
    <script type="text/javascript">
        function Smiliextra() {
        AddTxt=smiliecode[document.addsmileys.smiliextra_list.value];
        AddText(AddTxt);
        }

        function smiliewin() {
        window.open("$smiliewinlink", 'list', 'width=$winwidth,height=$winheight, scrollbars=yes');
        }

        function showimage() {
        document.images.icons.src="$imagesdir/"+document.addsmileys.icon.options[document.addsmileys.icon.selectedIndex].value+".gif";
        }
    </script>
    <br />
~  or croak "$croak{'print'} smilies";

    opendir DIR, "$htmldir/Smilies";
    @contents = readdir DIR;
    closedir DIR;
    $i = 0;
    for my $line ( sort { uc($a) cmp uc $b } @contents ) {
        ( $name, $extension ) = split /[.]/xsm, $line;
        if (   $extension =~ /gif/ism
            || $extension =~ /jpg/ism
            || $extension =~ /jpeg/ism
            || $extension =~ /png/ism )
        {
            if ( $line !~ /banner/ism ) {
                $smilieslist       .= qq~           <option value='$i'>$name\n~;
                $smilie_url_array  .= qq~"$yyhtml_root/Smilies/$line", ~;
                $smilie_code_array .= qq~" [smiley=$line]", ~;
                $i++;
            }
        }
    }
    $smilie_url_array  .= q~""~;
    $smilie_code_array .= q~""~;

    print qq~
        <script type="text/javascript">
        smilieurl = new Array($smilie_url_array)
        smiliecode = new Array($smilie_code_array)
        </script>
        <table class="bordercolor center">
            <tr>
                <td class="titlebg center" style="padding:2px; height:15px" colspan="2"><span class="small"><b>$post_smiltxt{'1'}</b></span></td>
            </tr><tr>
                <td class="windowbg2 vtop center" style="height:20px; width:50%">
                    <select name="smiliextra_list" onchange="document.images.smiliextra_image.src= smilieurl[document.addsmileys .smiliextra_list.value]" style="width:114px; font-size:7pt">
      $smilieslist
                    </select>
                </td>
                <td class="windowbg2"><script type="text/javascript"> document.write('<img name="smiliextra_image" src="'+smilieurl[0]+'" alt="" onclick="javascript:Smiliextra()" style="cursor:hand">');</script></td>
            </tr>
        </table>
        </form>
        <br /><br />
    </div>
    </body>
</html>
~  or croak "$croak{'print'} Smilies";
    return;
}

sub CheckCanShout {
    ( $shout_mute_days, $shout_mute_until ) = split /[|]/xsm,
      ${ $uid . $username }{'lp_shout_muted'};

    if ($iamguest) {
        print qq~Content-type:text/html\n\n~  or croak "$croak{'print'} TOP";
        print qq~
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>$name_sb</title>
<meta http-equiv="Content-Type" content="text/html; charset=$yymycharset" />
<meta http-equiv="pragma" CONTENT="no-cache" />
<link rel="stylesheet" href="$yyhtml_root/Templates/Forum/$usestyle.css" type="text/css" />
</head>
<table style="width:35%">
    <tr>
        <td>
            <span class="small">$shout_txt{'15'}<br /><br />$shout_txt{'16'} <a href="$scripturl?action=register" target="_blank">$scripturl</a></span>
            <br /><br />
            <a href="$boardurl/ShoutDisplay.pl">$shout_txt{'11'}</a>
        </td>
    </tr>
</table>
</body>
</html>~  or croak "$croak{'print'} BODY";

        exit;
    }
    elsif ( $shout_mute_until > int time ) {

        print qq~Content-type:text/html\n\n~  or croak "$croak{'print'} TOP";
        print qq~
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>$name_sb</title>
<meta http-equiv="Content-Type" content="text/html; charset=$yymycharset" />
<meta http-equiv="pragma" CONTENT="no-cache" />
<link rel="stylesheet" href="$yyhtml_root/Templates/Forum/$usestyle.css" type="text/css" />
</head>
<table style="width:40%">
    <tr>
        <td class="small">
            <span class="small">$shout_txt{'9'}<br /><br />
            ${$uid.$username}{'lp_shout_mute_reason'}<br /><br />
            $shout_txt{'10'} $shout_mute_days $shout_txt{'17'}</span>
            <br /><br />
            <a href="$boardurl/ShoutDisplay.pl">$shout_txt{'11'}</a>
        </td>
    </tr>
</table>
</body>
</html>~  or croak "$croak{'print'} BODY";
        exit;
    }
    elsif ( ${ $uid . $username }{'postcount'} < $min_posts ) {
        print qq~Content-type:text/html\n\n~  or croak "$croak{'print'} TOP";
        print qq~
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>$name_sb</title>
<meta http-equiv="Content-Type" content="text/html; charset=$yymycharset" />
<meta http-equiv="pragma" CONTENT="no-cache" />
<link rel="stylesheet" href="$yythml_root/Templates/Forum/$usestyle.css" type="text/css" />
</head>
<span class="small">$shout_txt{'12'} $min_posts times $shout_txt{'13'}<br /><br />
$shout_txt{'14'}<br /><a href="$scripturl">$scripturl</a></span>

<br /><br />
<a href="$boardurl/ShoutDisplay.pl">$shout_txt{'11'}</a>
</body>
</html>~  or croak "$croak{'print'} BODY";
        exit;
    }
}

sub ubbc_boxlist {
    my %list    = @_;
    my $hand    = q~class='vtop cursor' style='height:22px; width:23px;'~;
    my $boxlist = q{};
    my $w       = 0;
    for my $i ( sort keys %list ) {
        my ( $img, $click, $alt ) = split /[|]/xsm, $list{$i};
        $boxlist .=
qq~<span class="ubbcbutton ubbcbuttonback"><img src='$imagesdir/UBBC/$img' onclick='$click' $hand alt='$alt' title='$alt' /></span>\n~;
        $w++;
    }
    $boxlist_w = $w * 24;
    return ($boxlist, $boxlist_w);
}

sub smiley_list {
    my %list    = @_;
    my $hand    = q~class="vtop cursor" style="margin:1px;"~;
    my $boxlist = q{};
    my $w       = 0;
    for my $i ( sort keys %list ) {
        my ( $img, $click, $alt ) = split /[|]/xsm, $list{$i};
        my $autobr = q{};
        if ( $w == 8 && $shout_width < 380 ) {
            $autobr = q~<br />~;
        }
        $boxlist .=
qq~$autobr<img src='$imagesdir/$img' onclick='$click' $hand alt='$alt' title='$alt' />\n~;
        $w++;
    }
    return ($boxlist);
}
1;
